/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_addressSerializable implements PSerializable, Olstore_addressAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected java.lang.String city;
			protected java.lang.String country;
			protected  String jonasCMRUser_Address;
			protected java.lang.String postalCode;
			protected java.lang.String province;
			protected java.lang.String street1;
			protected java.lang.String street2;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_address";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetCity(java.lang.String val){
		city = val;
	}
	public java.lang.String paGetCity() {
		return city;
	}

	public void paSetCountry(java.lang.String val){
		country = val;
	}
	public java.lang.String paGetCountry() {
		return country;
	}

	public void paSetJonasCMRUser_Address(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRUser_Address = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRUser_Address = "null";
		}
	}
	
	public PName paGetJonasCMRUser_Address(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRUser_Address");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRUser_Address);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetPostalCode(java.lang.String val){
		postalCode = val;
	}
	public java.lang.String paGetPostalCode() {
		return postalCode;
	}

	public void paSetProvince(java.lang.String val){
		province = val;
	}
	public java.lang.String paGetProvince() {
		return province;
	}

	public void paSetStreet1(java.lang.String val){
		street1 = val;
	}
	public java.lang.String paGetStreet1() {
		return street1;
	}

	public void paSetStreet2(java.lang.String val){
		street2 = val;
	}
	public java.lang.String paGetStreet2() {
		return street2;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(city + ",  ");
					s.append(country + ",  ");
					s.append(jonasCMRUser_Address + ",  ");
					s.append(postalCode + ",  ");
					s.append(province + ",  ");
					s.append(street1 + ",  ");
					s.append(street2 + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_addressAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_addressAccessor)
			paccessor = (Olstore_addressAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetCity(paGetCity());
															paccessor.paSetCountry(paGetCountry());
															paccessor.paSetJonasCMRUser_Address(paGetJonasCMRUser_Address(pcm), null);
															paccessor.paSetPostalCode(paGetPostalCode());
															paccessor.paSetProvince(paGetProvince());
															paccessor.paSetStreet1(paGetStreet1());
															paccessor.paSetStreet2(paGetStreet2());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("city", paGetCity(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("country", paGetCountry(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("postalCode", paGetPostalCode(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("province", paGetProvince(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("street1", paGetStreet1(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("street2", paGetStreet2(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_addressAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_addressAccessor)
			paccessor = (Olstore_addressAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetCity(paccessor.paGetCity());
															paSetCountry(paccessor.paGetCountry());
															paSetJonasCMRUser_Address(paccessor.paGetJonasCMRUser_Address(pcm), null);
															paSetPostalCode(paccessor.paGetPostalCode());
															paSetProvince(paccessor.paGetProvince());
															paSetStreet1(paccessor.paGetStreet1());
															paSetStreet2(paccessor.paGetStreet2());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 				        	//	paSetStringField(city, paccessorGen.paGetCity());
        		//paSetStringField("city", paccessorGen.paGetStringField("city"));
        		//paSetCity(paccessorGen.paGetStringField("city"), null);
	        			 				        	//	paSetStringField(country, paccessorGen.paGetCountry());
        		//paSetStringField("country", paccessorGen.paGetStringField("country"));
        		//paSetCountry(paccessorGen.paGetStringField("country"), null);
	        			 						 				        	//	paSetStringField(postalCode, paccessorGen.paGetPostalCode());
        		//paSetStringField("postalCode", paccessorGen.paGetStringField("postalCode"));
        		//paSetPostalCode(paccessorGen.paGetStringField("postalCode"), null);
	        			 				        	//	paSetStringField(province, paccessorGen.paGetProvince());
        		//paSetStringField("province", paccessorGen.paGetStringField("province"));
        		//paSetProvince(paccessorGen.paGetStringField("province"), null);
	        			 				        	//	paSetStringField(street1, paccessorGen.paGetStreet1());
        		//paSetStringField("street1", paccessorGen.paGetStringField("street1"));
        		//paSetStreet1(paccessorGen.paGetStringField("street1"), null);
	        			 				        	//	paSetStringField(street2, paccessorGen.paGetStreet2());
        		//paSetStringField("street2", paccessorGen.paGetStringField("street2"));
        		//paSetStreet2(paccessorGen.paGetStringField("street2"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}